Index: src/rtghash.c
===========================================================================
--- src/rtghash.c	2004/11/03 14:26:17	#3
+++ src/rtghash.c	2004/11/03 14:26:17
@@ -3,398 +3,376 @@
    Author:      $Author: cbrotsos $
    Date:        $Date: 2004/08/25 19:18:26 $
    Description: RTG target hash table routines
+   Do You:      $Yahoo$
 ****************************************************************************/
 
 #include "common.h"
+
+#ifdef OLD_UCD_SNMP
+ #include "asn1.h"
+ #include "snmp_api.h"
+ #include "snmp_impl.h"
+ #include "snmp_client.h"
+ #include "mib.h"
+ #include "snmp.h"
+#else
+ #include "net-snmp-config.h"
+ #include "net-snmp-includes.h"
+#endif
+
 #include "rtg.h"
+#include "rtghash.h"
+#include "rtgsqlbuf.h"
+#include "rtgsnmp.h"
 
-#if NEW_TARGET_FORMAT
 extern FILE *yyin;
 extern int yyparse(void);
 extern int yylex(void);
 
-static void free_hash(void);
-static void *in_hash(target_t *entry, target_t *list);
-static void mark_targets(int state);
-static void walk_target_hash(void);
+struct tgthash *thash;
+RTGLL_HEAD(, dbtable_struct) dbtable_h = RTGLL_HEAD_INITIALIZER();
+RTGLL_HEAD(, host_struct) host_h = RTGLL_HEAD_INITIALIZER();
+static unsigned int hosts = 0U;
+
 static int compare_targets(target_t *t1, target_t *t2);
-static unsigned int delete_targets(int state);
-static unsigned long make_key(const void *entry);
+static target_t *in_hash(struct tgthead *table, target_t *entry);
+static int tgthead_delete(struct tgthead *tblhead, target_t *new);
 
-static int entries = 0;
-struct {
-        int bucket;
-        target_t *target;
-		target_t **table;
-} hash;
-#endif
-
+static void host_decrement(struct host_struct *dhst);
+static void dbtable_decrement(struct dbtable_struct *dtbl);
 
 /* Initialize hash table */
-void init_hash() {
-	int i;
+void
+tgthash_init(struct tgthash *hash, unsigned int hashsize)
+{
+	unsigned int i;
 
-#if !NEW_TARGET_FORMAT
-	for(i=0;i<HASHSIZE;i++) {
-		hash.table[i] = NULL;
+	hash->entries = 0;
+	hash->hashsize = hashsize;
+	hash->table = calloc(hashsize, sizeof(struct tgthead *));
+	for (i = 0; i < hashsize; i++) {
+		hash->table[i] = malloc(sizeof(struct tgthead));
+		RTGLL_INIT(hash->table[i]);
 	}
-#else
-	hash.table = calloc(HASHSIZE, sizeof(target_t *));
-#endif
-	debug(LOW, "Initialize hash table pointers: %d bytes.\n",
-		HASHSIZE * sizeof(target_t *));
+	debug(LOW, "Hashtable allocated: %u buckets, %d bytes.\n",
+		hashsize, (hashsize * sizeof(struct tgthead)) +
+			  (hashsize * sizeof(struct tgthead *)));
+	tgthash_init_walk(hash);
 }
 
-
-void init_hash_walk() {
-	hash.bucket = 0;
-	hash.target = hash.table[hash.bucket];
+void
+tgthash_init_walk(struct tgthash *hash)
+{
+	hash->bucket = 0;
+	hash->target = RTGLL_FIRST(hash->table[0]);
 }
 
+target_t *
+tgthash_next(struct tgthash *hash)
+{
+	target_t *new;
 
-target_t *getNext() {
-	target_t *next = NULL;
-
-	while (!(hash.target)) {
-		(hash.bucket)++;
-		if (hash.bucket >= HASHSIZE) 
-			return NULL;
-		hash.target = hash.table[hash.bucket];	
+	while (hash->target == NULL) {
+		if (++(hash->bucket) == hash->hashsize) 
+			return (NULL);
+		if (RTGLL_EMPTY(hash->table[hash->bucket]))
+			continue;
+		hash->target = RTGLL_FIRST(hash->table[hash->bucket]);
 	}
-	next = hash.target;
-	hash.target = (hash.target)->next;
-	return next;
+	new = hash->target;
+	hash->target = RTGLL_NEXT(new, next);
+	return (new);
 }
 
-
 /* Free hash table memory */
-#if !NEW_TARGET_FORMAT
-void free_hash() {
-#else
-static void free_hash() {
-#endif
-	target_t *ptr = NULL;
-	target_t *f = NULL;
-	int i;
+static void
+tgthash_free(struct tgthash *hash)
+{
+	target_t *ptr = NULL, *f = NULL;
+	unsigned int i;
 
-	for(i=0;i<HASHSIZE;i++) {
-		ptr = hash.table[i];
-		while (ptr) {
-			f = ptr;
-			ptr = ptr->next;
-#if NEW_TARGET_FORMAT
-			if (f->host != NULL) {
-				free(f->host);
-			}
-#endif
-			free(f);	
+	for (i = 0; i < hash->hashsize; i++) {
+		struct tgthead *tbl = hash->table[i];
+		RTGLL_FOREACH_SAFE(ptr, tbl, next, f) {
+			RTGLL_REMOVE(tbl, ptr, target_struct, next);
+			free(ptr);	
 		}	
 	}
 }
 
-
 /* Hash the target */
-#if !NEW_TARGET_FORMAT
-unsigned long make_key(const void *entry) {
-#else
-static unsigned long make_key(const void * entry) {
-#endif
-	const target_t *t = (const target_t *) entry;
-	const char *h = (const char *) t->host;
-	const char *o = (const char *) t->objoid;
+static unsigned long
+make_key(target_t *t)
+{
 	unsigned long hashval;
 
-    if (!h) return 0;
-
-	for (hashval = 0; *o != '\0'; o++)
-		hashval = (((unsigned int) *o) | 0x20) + 31 * hashval;
-	for (;*h != '\0'; h++)
-		hashval = (((unsigned int) *h) | 0x20) + 31 * hashval;
-    
-    return (hashval % HASHSIZE);
+	hashval = fnv_32_str(t->host->s->peername, FNV1_32_INIT);
+	if (t->description)
+		hashval = fnv_32_str(t->description, hashval);
+	hashval = fnv_32_str(t->objoid, hashval);
+	return (fnv_32_str(t->dbt->table, hashval));
 }
 
-
 /* Set state of all targets to state - used on init, update targets, etc */ 
-#if !NEW_TARGET_FORMAT
-void mark_targets(int state) {
-#else
-static void mark_targets(int state) {
-#endif
+static unsigned int
+mark_targets(struct tgthash *hash, enum targetState state)
+{
 	target_t *p = NULL;
-	int i = 0;
+	unsigned int i, x = 0;
 
-	for (i=0;i<HASHSIZE;i++) {
-		p = hash.table[i];
-		while (p) {
+	for (i = 0; i < hash->hashsize; i++) {
+		RTGLL_FOREACH(p, hash->table[i], next) {
 			p->init = state;
-			p = p->next;
+			x++;
 		}
 	}
+	return (x);
 }
 
-
 /* Delete targets marked with state = state */
-#if !NEW_TARGET_FORMAT
-int delete_targets(int state) {
-#else
-static unsigned int delete_targets(int state) {
-#endif
-	target_t *p = NULL;
-	target_t *d = NULL;
-	int i = 0;
-#if !NEW_TARGET_FORMAT
-	int entries = 0;
-#else
-	unsigned int deleted = 0;
-#endif
+unsigned int
+delete_targets(struct tgthash *hash, enum targetState state)
+{
+	target_t *p, *d;
+	unsigned int i, deleted = 0;
 
-	for (i=0;i<HASHSIZE;i++) {
-		p = hash.table[i];
-		while (p) {
-			d = p;
-			p = p->next;
-			if (d->init == state) {
-				del_hash_entry(d);
-#if !NEW_TARGET_FORMAT
-				entries++;
-#else
+	for (i = 0; i < hash->hashsize; i++) {
+		struct tgthead *tbl = hash->table[i];
+		RTGLL_FOREACH_SAFE(p, tbl, next, d) {
+			if (p->init != state)
+				continue;
+			if (tgthead_delete(tbl, p)) {
+				hash->entries--;
 				deleted++;
-#endif
 			}
 		}
 	}
-#if !NEW_TARGET_FORMAT
-	return entries;
-#else
-	return deleted;
-#endif
+	return (deleted);
 }
 
-
-/* Dump the entire target hash [sequential num/bucket number] */
-#if !NEW_TARGET_FORMAT
-void walk_target_hash() {
-#else
-static void walk_target_hash() {
-#endif
-	target_t *p = NULL;
-	int targets = 0;
-	int i = 0;
+/* Dump the entire target hash */
+void
+walk_target_hash(struct tgthash *hash)
+{
+	target_t *p;
+	unsigned int i, targets = 0;
 	
-    printf("Dumping Target List:\n");
-	for (i=0;i<HASHSIZE;i++) {
-		p = hash.table[i];
-		while (p) {
-#if NEW_TARGET_FORMAT
-			printf("[%d/%d]: %s %s %d %s %s %d\n", targets, i,
-				p->host->host, p->objoid, p->bits,
-				p->host->community, p->table, p->iid);
-#else
-			printf("[%d/%d]: %s %s %d %s %s %d\n", targets, i, p->host,
-				p->objoid, p->bits, p->community, p->table, 
-				p->iid);
-#endif
-			targets++;
-			p = p->next;
+	fprintf(dfp, "Dumping Target List:\n");
+	for (i=0; i < hash->hashsize; i++) {
+		RTGLL_FOREACH(p, hash->table[i], next) {
+			fprintf(dfp, "[%d/%d]: %01x/%s/%s/%d/%s/%s/%d/%lld\n",
+				++targets, i, p->init, p->host->s->peername,
+				p->objoid, p->bits, p->host->s->community,
+				p->dbt->table, p->iid, p->maxspeed);
 		}
 	}
-    printf("Total of %u targets [%u bytes of memory].\n",
-	   targets, targets * sizeof(target_t));
+	fprintf(dfp, "Total of %u targets [%u bytes of memory].\n",
+		targets, targets * sizeof(target_t));
 }
 
+/* return ptr to target if the entry exists in the named list */
+static target_t *
+in_hash(struct tgthead *table, target_t *entry)
+{
+	target_t *p = NULL;
 
-/* return ptr to target if the entry exists in the named list */
-#if !NEW_TARGET_FORMAT
-void *in_hash(target_t *entry, target_t *list) {
-#else
-static void *in_hash(target_t *entry, target_t *list) {
-#endif
-	while (list) {
-		if (compare_targets(entry, list)) {
-			debug(HIGH, "Found existing %s %s %s %d\n", list->host,
-				list->objoid, list->table, list->iid);
-			return list;
-		}
-		list = list->next;
+	RTGLL_FOREACH(p, table, next) {
+		if (p == entry)
+			return (p);
+		if (compare_targets(p, entry) == FALSE)
+			continue;
+		return (p);
 	}
-	return NULL;
+	return (NULL);
 }
 
+/* TRUE if target 1 == target 2 */
+static int
+compare_targets(target_t *t1, target_t *t2)
+{
 
-/* TRUE if target 1 == target 2 */
-#if !NEW_TARGET_FORMAT
-int compare_targets(target_t *t1, target_t *t2) {
-	if (!strcmp(t1->host, t2->host) &&
-		!strcmp(t1->objoid, t2->objoid) &&
-		!strcmp(t1->table, t2->table) &&
-		!strcmp(t1->community, t2->community) &&
-		(t1->iid == t2->iid)) 
-			return TRUE;
-#else
-static int compare_targets(target_t *t1, target_t *t2) {
-	if (!strcmp(t1->host->host, t2->host->host) &&
-		!strcmp(t1->objoid, t2->objoid) &&
-		!strcmp(t1->table, t2->table) &&
-		!strcmp(t1->host->community, t2->host->community) &&
-		(t1->iid == t2->iid)) 
-			return TRUE;
-#endif
-	return FALSE;
+	debug(DEVELOP, "compare: %p=%p %p=%p %u=%u %s=%s\n",
+	      t1->host, t2->host, t1->dbt, t2->dbt, t1->iid, t2->iid,
+	      t1->objoid, t2->objoid);
+	if ((t1->iid != t2->iid) ||
+	    (t1->host != t2->host) ||
+	    (t1->dbt != t2->dbt) ||
+	    (strcmp(t1->objoid, t2->objoid) != 0)) {
+			return (FALSE);
+	}
+	return (TRUE);
 }
 
-
 /* Remove an item from the list.  Returns TRUE if successful. */
-int del_hash_entry(target_t *new) {
-    target_t *p = NULL;
-    target_t *prev = NULL;
-	unsigned int key;
+static int
+tgthead_delete(struct tgthead *tblhead, target_t *del)
+{
+	target_t *p;
 
-	key = make_key(new);
-#if !NEW_TARGET_FORMAT
-	if (!in_hash(new, hash.table[key]))
-		return FALSE;
-#else
-	if(in_hash(new, hash.table[key]) == NULL)
-		return FALSE;
-#endif
+	p = in_hash(tblhead, del);
+	if (p == NULL)
+		return (FALSE);
 	
-	p = hash.table[key];
-	/* assert(p != NULL) */
-	while (p) {
-		if (compare_targets(p, new)) {
-			/* if successor, we need to point predecessor to it (if exists) */
-			if (p->next) {
-				/* there is a predecessor */
-				if (prev) 
-					prev->next = p->next;
-				/* there is no predecessor */
-				else 
-					hash.table[key] = p->next;
-			}
-			/* no successor, delete just this target */
-			else {
-				if (prev) 
-					prev->next = NULL;
-				else 
-					hash.table[key] = NULL;
-			}
-			free (p);
-			return TRUE;
-		}
-		prev = p;
-		p = p->next;
-	}	
-	return FALSE;
+	RTGLL_REMOVE(tblhead, p, target_struct, next);
+	dbtable_decrement(p->dbt);
+	host_decrement(p->host);
+	free(p->description);
+	free(p->objoid);
+	free(p->oid);
+	free(p);
+
+	return (TRUE);
 }
 
-
 /* Add an entry to hash if it is unique, otherwise free() it */
-int add_hash_entry(target_t *new) {
-    target_t *p = NULL;
-	unsigned int key;
+int
+tgthash_insert(struct tgthash *hash, target_t *new)
+{
+	struct tgthead *head; 
+	target_t *p;
 
-	key = make_key(new);
-#if !NEW_TARGET_FORMAT
-	p = hash.table[key];
-#endif
-
-	p = in_hash(new, hash.table[key]);
-	if (p) {
+	head = hash->table[make_key(new) % hash->hashsize];
+	if ((p = in_hash(head, new)) != NULL) {
 		p->init = LIVE;
 		free(new);
-		return FALSE;
+		return (FALSE);
 	} 
 
-	if (!hash.table[key]) {
-		hash.table[key] = new;
-	} else {
-		p = hash.table[key];
-		while (p->next) p = p->next;
-		p->next = new;
-	}
-#if NEW_TARGET_FORMAT
-	entries++;
-#endif
-	return TRUE;
+	new->init = NEW;
+	if (!rtg_read_objid(new))
+		return (FALSE);
+	if (new->maxspeed == 0)
+		new->maxspeed = DEFAULT_OUT_OF_RANGE;
+	RTGLL_INSERT_HEAD(head, new, next);
+	hash->entries++;
+	new->host->refcnt++;
+	return (TRUE);
 }
 
-
 /* Read a target file into a target_t hash table. 
- * Our hash algorithm roughly randomizes targets, easing SNMP load
+ * The fnv hash algorithm effectively randomizes targets, easing SNMP load
  * on end devices during polling.
  * hash_target_file() can be called again to update the target
  * hash.  If hash_target_file() finds new target entries in the file, it
- * adds them to the hash via add_hash_entry().
- * If hash_target_file() finds entries in hash but not in file,
- * it removes said entries from hash via delete_targets().
- * The return values of the addition/deletion functions are then
- * added to/subtracted from the static integer 'entries' which keeps a running
- * count of the total number of targets being polled since the start of rtgpoll.
+ * adds them to the hash via tgthash_insert().
+ * If hash_target_file() finds stale entries in the hash,
+ * it removes those entries from the hash via delete_targets().
  */
-int hash_target_file(char *file) {
-#if !NEW_TARGET_FORMAT
-    FILE *fp;
-    target_t *new = NULL;
-    char buffer[BUFSIZE];
-    static int entries = 0;
-    int removed = 0;
-    char maxspeed[30];
-#else
-    unsigned int removed = 0;
-#endif
+unsigned int
+hash_target_file(char *file)
+{
+	unsigned int removed;
 
-    /* Open the target file */
-#if !NEW_TARGET_FORMAT
-	if ((fp = fopen(file, "r")) == NULL) {
-#else
+	if (file == NULL) {
+		fprintf(stderr, "targets file must be provided.\n");
+		return (0);
+	}
 	if ((yyin = fopen(file, "r")) == NULL) {
-#endif
-		fprintf(stderr, "\nCould not open %s for reading.\n", file);
-		return (-1);
+		fprintf(stderr, "Could not open %s for reading.\n", file);
+		return (0);
 	} 
+	removed = delete_targets(thash, ERR);
+	mark_targets(thash, STALE);
 	debug(LOW, "Reading RTG target list [%s].\n", file);
+	yyparse();
+	fclose(yyin);
+	removed += delete_targets(thash, STALE);
+	debug(LOW, "Successfully hashed [%u] targets, (%u bytes).\n",
+		thash->entries, thash->entries * sizeof(target_t));
+	if (removed)
+		debug(LOW, "Removed [%u] stale targets from hash.\n", removed);
+	if (set.verbose >= DEBUG)
+		walk_target_hash(thash);
+	return (thash->entries);
+}
+
+struct host_struct *
+host_insert(struct config_snmphost *c)
+{
+	struct host_struct *thst;
+
+	RTGLL_FOREACH(thst, &host_h, next) {
+		if (snmp_comparehost(thst->s, c))
+			return (thst);
+	}
+	thst = malloc(sizeof(struct host_struct));
+	debug(DEVELOP, "inserting host %s (%p)\n", c->host, thst);
+	thst->refcnt = 1;
+	snmp_confighost(thst, c);
+	if (pthread_mutex_init(&thst->mutex, NULL))
+		fatal("cannot init mutex for %s\n", c->host);
+	RTGLL_INSERT_HEAD(&host_h, thst, next);
+	hosts++;
+	return (thst);
+}
+
+static void
+host_decrement(struct host_struct *dhst)
+{
+
+	if (--(dhst->refcnt))
+		return;
+
+	RTGLL_REMOVE(&host_h, dhst, host_struct, next);
+	if (pthread_mutex_destroy(&dhst->mutex))
+		fatal("cannot destroy mutex for %s", dhst->s->peername);
+	free(dhst->s->peername);
+	free(dhst->s->community);
+	free(dhst->s);
+	free(dhst);
+	hosts--;
+}
+
+unsigned int
+host_count(void)
+{
+
+	return (hosts);
+}
+
+struct dbtable_struct *
+dbtable_insert(const char *ntable)
+{
+	struct dbtable_struct *tdbt;
+
+	RTGLL_FOREACH(tdbt, &dbtable_h, next) {
+		if (strcmp(tdbt->table, ntable))
+			continue;
+		tdbt->refcnt++;
+		return (tdbt);
+	}
+	tdbt = malloc(sizeof(struct dbtable_struct));
+	tdbt->table = strdup(ntable);
+	tdbt->sbuf = sqlbuf_create(ntable);
+	tdbt->refcnt = 1;
+	if (pthread_mutex_init(&tdbt->mutex, NULL))
+		fatal("cannot init mutex for %s\n", ntable);
+	RTGLL_INSERT_HEAD(&dbtable_h, tdbt, next);
+	return (tdbt);
+}
 
-	mark_targets(STALE);
-#if !NEW_TARGET_FORMAT
-    /* Read each unique target into hash table */
-	while (!feof(fp)) {
-		fgets(buffer, BUFSIZE, fp);
-		if (!feof(fp) && buffer[0] != '#' && buffer[0] != ' ' && buffer[0] != '\n') {
-			new = (target_t *) malloc(sizeof(target_t));
-			if (!new) 
-				fatal("Fatal target malloc error!\n");
-			sscanf(buffer, "%64s %128s %hu %64s %64s %d %30s",
-			       new->host, new->objoid, &(new->bits),
-			       new->community, new->table,
-			       &(new->iid), maxspeed);
-			if (alldigits(maxspeed)) {
-#ifdef HAVE_STRTOLL
-				new->maxspeed = strtoll(maxspeed, NULL, 0);
-#else
-				new->maxspeed = strtol(maxspeed, NULL, 0);
-#endif
-			} else {
-				new->maxspeed = set.out_of_range;
-			}
-			debug(DEBUG, "Host[OID][OutOfRange]:%s[%s][%lld]\n",
-				new->host, new->objoid, new->maxspeed);
-			new->init = NEW;
-			new->last_value = 0;
-			new->next = NULL;
-			entries += add_hash_entry(new);
-		}
+static void
+dbtable_decrement(struct dbtable_struct *dtbl)
+{
+
+	if (--(dtbl->refcnt)) {
+		sqlbuf_resize(dtbl->sbuf, dtbl->refcnt);
+		return;
+	}
+	RTGLL_REMOVE(&dbtable_h, dtbl, dbtable_struct, next);
+	sqlbuf_free(dtbl->sbuf);
+	if (pthread_mutex_destroy(&(dtbl->mutex)))
+		fatal("cannot destroy mutex for %s", dtbl->table);
+	free(dtbl->table);
+	free(dtbl);
+}
+
+void
+dbtable_sqltune_all(void)
+{
+	struct dbtable_struct *tdbt;
+
+	RTGLL_FOREACH(tdbt, &dbtable_h, next) {
+		sqlbuf_resize(tdbt->sbuf, tdbt->refcnt);
 	}
-	fclose(fp);
-#else
-	yyparse();
-	fclose(yyin);
-#endif
-	removed = delete_targets(STALE);
-	entries -= removed;
-	debug(LOW, "Successfully hashed [%d] targets, (%d bytes).\n",
-		entries, entries * sizeof(target_t));
-	if (removed > 0)
-		debug(LOW, "Removed [%d] stale targets from hash.\n", removed);
-	return (entries);
 }
Index: src/rtghash.h
===========================================================================
*** /dev/null	Wed Nov  3 14:22:00 2004
--- src/rtghash.h	Wed Nov  3 14:26:18 2004
***************
*** 0 ****
--- 1,140 ----
+ /*
+  * Fowler / Noll / Vo Hash (FNV Hash)
+  * http://www.isthe.com/chongo/tech/comp/fnv/
+  *
+  * This is an implementation of the algorithms posted above.
+  * This file is placed in the public domain by Peter Wemm.
+  *
+  * $FreeBSD: src/sys/sys/fnv_hash.h,v 1.2 2001/03/20 02:10:18 peter Exp $
+  */
+ 
+ typedef u_int32_t Fnv32_t;
+ 
+ #define FNV1_32_INIT ((Fnv32_t) 33554467UL)
+ #define FNV_32_PRIME ((Fnv32_t) 0x01000193UL)
+ 
+ static __inline Fnv32_t
+ fnv_32_buf(const void *buf, size_t len, Fnv32_t hval)
+ {
+ 	const u_int8_t *s = (const u_int8_t *)buf;
+ 
+ 	while (len-- != 0) {
+ 		hval *= FNV_32_PRIME;
+ 		hval ^= *s++;
+ 	}
+ 	return hval;
+ }
+ 
+ static __inline Fnv32_t
+ fnv_32_str(const char *str, Fnv32_t hval)
+ {
+ 	const u_int8_t *s = (const u_int8_t *)str;
+ 	Fnv32_t c;
+ 
+ 	while ((c = *s++) != 0) {
+ 		hval *= FNV_32_PRIME;
+ 		hval ^= c;
+ 	}
+ 	return hval;
+ }
+ 
+ /*
+  * Copyright (C) 2004 bill fumerola. All rights reserved.
+  * 
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 
+  * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $Yahoo: //depot/fumerola/rtg-contrib/src/rtghash.h#28 $
+  */ 
+ 
+ #include "rtglist.h"
+ 
+ struct dbtable_struct {
+ 	char *table;
+ 	unsigned int refcnt;
+ 	struct sqlbuf *sbuf;
+ 	pthread_mutex_t mutex;
+ 	RTGLL_ENTRY(dbtable_struct) next;
+ };
+ 
+ struct host_struct {
+ 	unsigned int refcnt;
+ 	struct snmp_session *s;
+ 	pthread_mutex_t mutex;
+ 	RTGLL_ENTRY(host_struct) next;
+ };
+ 
+ /* Target state */
+ enum targetState {
+ 	NEW =	0x01,	/* added but never polled */
+ 	LIVE =	0x02,	/* successfully been polled */
+ 	STALE = 0x04,	/* in memory, but not in targets file */
+ 	ERR = 	0x08,	/* poll resulted in a hard or non-transient error */
+ 	TIME =	0x10	/* poll resulted in a timeout or soft error */
+ };
+ 
+ typedef struct target_struct {
+ 	struct host_struct *host;
+ 	struct dbtable_struct *dbt;
+ 	char *description;
+ 	char *objoid;
+ 	struct rtg_oid *oid;
+ 	unsigned short bits;
+ 	unsigned int iid;
+ #ifdef HAVE_UNSIGNED_LONG_LONG
+ 	unsigned long long maxspeed;
+ 	unsigned long long last_value;
+ #else
+ 	unsigned long maxspeed;
+ 	unsigned long last_value;
+ #endif
+ 	enum targetState init;
+ #ifdef FEATURES
+ 	struct timeval last_time;
+ #endif
+ 	RTGLL_ENTRY(target_struct) next;
+ } target_t;
+ 
+ struct tgthash {
+ 	unsigned int bucket, entries, hashsize;
+ 	target_t *target;
+ 	RTGLL_HEAD(tgthead, target_struct) **table;
+ };
+ 
+ extern struct tgthash *thash;
+ 
+ struct config_snmphost {
+ 	char *host, *community;
+ 	unsigned short snmp_ver, snmp_port;
+ 	long timeout;
+ 	int retries;
+ };
+ 
+ unsigned int delete_targets(struct tgthash *hash, enum targetState state);
+ void tgthash_init(struct tgthash *hash, unsigned int hashsize);
+ void tgthash_init_walk(struct tgthash *hash);
+ target_t *tgthash_next(struct tgthash *hash);
+ int tgthash_insert(struct tgthash *hash, target_t *new);
+ unsigned int hash_target_file(char *file);
+ struct host_struct *host_insert(struct config_snmphost *c);
+ unsigned int host_count(void);
+ struct dbtable_struct *dbtable_insert(const char *ntable);
+ void dbtable_sqltune_all(void);
Index: src/rtglist.h
===========================================================================
*** /dev/null	Wed Nov  3 14:22:00 2004
--- src/rtglist.h	Wed Nov  3 14:26:18 2004
***************
*** 0 ****
--- 1,96 ----
+ /*
+  * Copyright (c) 1991, 1993
+  *	The Regents of the University of California.  All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 4. Neither the name of the University nor the names of its contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  *	@(#)queue.h	8.5 (Berkeley) 8/20/94
+  * $FreeBSD: src/sys/sys/queue.h,v 1.58 2004/04/07 04:19:49 imp Exp $
+  * $Yahoo: //depot/fumerola/rtg-contrib/src/rtglist.h#3 $
+  */
+ 
+ #define	RTGLL_HEAD(name, type)						\
+ struct name {								\
+ 	struct type *rlh_first;	/* first element */			\
+ }
+ 
+ #define	RTGLL_HEAD_INITIALIZER()					\
+ 	{ NULL }
+ 
+ #define	RTGLL_ENTRY(type)						\
+ struct {								\
+ 	struct type *rle_next;	/* next element */			\
+ }
+ 
+ #define	RTGLL_EMPTY(head)	((head)->rlh_first == NULL)
+ 
+ #define	RTGLL_FIRST(head)	((head)->rlh_first)
+ 
+ #define	RTGLL_FOREACH(var, head, field)					\
+ 	for ((var) = RTGLL_FIRST((head));				\
+ 	    (var);							\
+ 	    (var) = RTGLL_NEXT((var), field))
+ 
+ #define	RTGLL_FOREACH_SAFE(var, head, field, tvar)			\
+ 	for ((var) = RTGLL_FIRST((head));				\
+ 	    (var) && ((tvar) = RTGLL_NEXT((var), field), 1);		\
+ 	    (var) = (tvar))
+ 
+ #define	RTGLL_FOREACH_PREVPTR(var, varp, head, field)			\
+ 	for ((varp) = &RTGLL_FIRST((head));				\
+ 	    ((var) = *(varp)) != NULL;					\
+ 	    (varp) = &RTGLL_NEXT((var), field))
+ 
+ #define	RTGLL_INIT(head) do {						\
+ 	RTGLL_FIRST((head)) = NULL;					\
+ } while (0)
+ 
+ #define	RTGLL_INSERT_AFTER(slistelm, elm, field) do {			\
+ 	RTGLL_NEXT((elm), field) = RTGLL_NEXT((slistelm), field);	\
+ 	RTGLL_NEXT((slistelm), field) = (elm);				\
+ } while (0)
+ 
+ #define	RTGLL_INSERT_HEAD(head, elm, field) do {			\
+ 	RTGLL_NEXT((elm), field) = RTGLL_FIRST((head));			\
+ 	RTGLL_FIRST((head)) = (elm);					\
+ } while (0)
+ 
+ #define	RTGLL_NEXT(elm, field)	((elm)->field.rle_next)
+ 
+ #define	RTGLL_REMOVE(head, elm, type, field) do {			\
+ 	if (RTGLL_FIRST((head)) == (elm)) {				\
+ 		RTGLL_REMOVE_HEAD((head), field);			\
+ 	} else {							\
+ 		struct type *curelm = RTGLL_FIRST((head));		\
+ 		while (RTGLL_NEXT(curelm, field) != (elm))		\
+ 			curelm = RTGLL_NEXT(curelm, field);		\
+ 		RTGLL_NEXT(curelm, field) =				\
+ 		    RTGLL_NEXT(RTGLL_NEXT(curelm, field), field);	\
+ 	}								\
+ } while (0)
+ 
+ #define	RTGLL_REMOVE_HEAD(head, field) do {				\
+ 	RTGLL_FIRST((head)) = RTGLL_NEXT(RTGLL_FIRST((head)), field);	\
+ } while (0)
Index: src/rtgmysql.c
===========================================================================
--- src/rtgmysql.c	2004/11/03 14:26:17	#3
+++ src/rtgmysql.c	2004/11/03 14:26:17
@@ -3,38 +3,25 @@
    Author:      $Author: rbeverly $
    Date:        $Date: 2004/03/07 02:53:45 $
    Purpose:     RTG MySQL routines
+   Do You:      $Yahoo$
 ****************************************************************************/
 
 #include "common.h"
 #include "rtg.h"
 
 #if HAVE_MYSQL
-extern FILE *dfp;
 
-int mysql_db_insert(char *query, MYSQL * mysql)
+int mysql_dbconnect(char *database, MYSQL * mysql)
 {
-    if (mysql_query(mysql, query)) {
-		debug(LOW, "** MySQL Error: %s\n", mysql_error(mysql));
-		return (FALSE);
-    }
-	return (TRUE);
-}
 
-
-int mysql_dbconnect(char *database, MYSQL * mysql)
-{
-    if (set.verbose >= LOW) {
-		if(set.daemon)
-			sysloginfo("Connecting to MySQL database '%s' on '%s'...", database, set.dbhost);
-		else
-			fprintf(dfp, "Connecting to MySQL database '%s' on '%s'...", database, set.dbhost);
+	debug(LOW, "Connecting to MySQL database '%s' on '%s'...", database,
+	      set.dbhost);
+	mysql_init(mysql);
+	if (!mysql_real_connect(mysql, set.dbhost, set.dbuser, set.dbpass,
+	    database, set.dbport, (set.dbsock[0]) ? set.dbsock : NULL, 0)) {
+		fprintf(dfp, "** Failed: %s\n", mysql_error(mysql));
+		return (-1);
 	}
-    mysql_init(mysql);
-    if (!mysql_real_connect
-     (mysql, set.dbhost, set.dbuser, set.dbpass, database, 0, NULL, 0)) {
-	fprintf(dfp, "** Failed: %s\n", mysql_error(mysql));
-	return (-1);
-    } else
 	return (0);
 }
 
@@ -47,10 +34,11 @@
 void mysql_close_db(void *arg)
 {
 	/* to be called from the cleanup handler */
-	if (MYSQL_VERSION_ID > 40000)
-		mysql_thread_end();
-	else
-		my_thread_end();
+#if MYSQL_VERSION_ID > 40000
+	mysql_thread_end();
+#else
+	my_thread_end();
+#endif
 	mysql_close(arg);
 }
 
Index: src/rtgplot.c
===========================================================================
--- src/rtgplot.c	2004/11/03 14:26:17	#7
+++ src/rtgplot.c	2004/11/03 14:26:17
@@ -5,6 +5,7 @@
    Description: RTG traffic grapher
                 Utilizes cgilib (http://www.infodrom.org/projects/cgilib/)
                 for the CGI interface.
+   Do You:      $Yahoo$
 ****************************************************************************/
 
 /*
@@ -54,12 +55,10 @@
 #include "rtgplot.h"
 #include "cgi.h"
 
-#if NEW_TARGET_FORMAT
 config_t set;
 int lock;
 int waiting;
 char config_paths[CONFIG_PATHS][BUFSIZE];
-#endif
 
 /* dfp is a debug file pointer.  Points to stderr unless debug=level is set */
 FILE *dfp = NULL;
@@ -157,7 +156,7 @@
 
 	bzero(&arguments, sizeof(arguments_t));
 	bzero(&graph, sizeof(graph_t));
-	config_defaults(&set);
+	config_defaults();
 	sizeDefaults(&graph);
 
 	/* Called from the command line with arguments */
@@ -172,20 +171,15 @@
 
 	/* Read configuration file to establish local environment */
 	if (arguments.conf_file) {
-		if ((read_rtg_config(arguments.conf_file, &set)) < 0) 
+		if ((read_rtg_config(arguments.conf_file)) < 0) 
 			fatalfile(dfp, "Could not read config file: %s\n", arguments.conf_file);
 	} else {
 		arguments.conf_file = malloc(BUFSIZE);
 		for (i = 0; i < CONFIG_PATHS; i++) {
-			snprintf(arguments.conf_file, BUFSIZE, "%s%s", config_paths[i], DEFAULT_CONF_FILE);
-			if (read_rtg_config(arguments.conf_file, &set) >= 0) {
+			snprintf(arguments.conf_file, BUFSIZE, "%s%s",
+			    config_paths[i], DEFAULT_CONF_FILE);
+			if (read_rtg_config(arguments.conf_file) == 0)
 				break;
-			}
-			if (i == CONFIG_PATHS - 1) {
-				snprintf(arguments.conf_file, BUFSIZE, "%s%s", config_paths[0], DEFAULT_CONF_FILE);
-				if ((write_rtg_config(arguments.conf_file, &set)) < 0) 
-					fatalfile(dfp, "Couldn't write config file.\n");
-			}
 		}
 	}
 
@@ -396,7 +390,7 @@
 	fprintf(dfp, "Dumping data:\n");
 	entry = head;
 	while (entry != NULL) {
-		fprintf(dfp, "  [%d] Count: %lld TS: %ld Rate: %2.3f X: %d Y: %d\n",
+		fprintf(dfp, "  [%d] Count: %llu TS: %ld Rate: %2.3f X: %d Y: %d\n",
 		       ++i, entry->counter, entry->timestamp, entry->rate,
 		       entry->x, entry->y);
 		entry = entry->next;
@@ -459,17 +453,17 @@
 			fprintf(dfp, "  Fatal malloc error in populate.\n");
 		/* Seems atoll is not very portable, nor desirable */
 		/* new->counter = atoll(row[0]); */
-#ifdef HAVE_STRTOLL
+#ifdef HAVE_STRTOULL
 #if HAVE_MYSQL
-		new->counter = strtoll(row[0], NULL, 0);
+		new->counter = strtoull(row[0], NULL, 0);
 #elif HAVE_PGSQL
-		new->counter = strtoll(PQgetvalue(result, i, 0), NULL, 0);
+		new->counter = strtoull(PQgetvalue(result, i, 0), NULL, 0);
 #endif
 #else
 #if HAVE_MYSQL
-		new->counter = strtol(row[0], NULL, 0);
+		new->counter = strtoul(row[0], NULL, 0);
 #elif HAVE_PGSQL
-		new->counter = strtol(PQgetvalue(result, i, 0), NULL, 0);
+		new->counter = strtoul(PQgetvalue(result, i, 0), NULL, 0);
 #endif
 #endif
 #if HAVE_MYSQL
@@ -1201,7 +1195,7 @@
 }
 
 
-#ifdef HAVE_STRTOLL
+#ifdef HAVE_LONG_LONG
 //long long intSpeed(MYSQL *mysql, int iid) {
 long long intSpeed(void *sql, int iid) {
 #else
